//
//  Possession.m
//  
//
//  Created by Daniel Dyba on 9/20/11.
//

#import "Possession.h"

@implementation Possession

@synthesize possessionName, serialNumber, valueInDollars, dateCreated, imageKey;

- (void)dealloc
{
    [possessionName release];
    [serialNumber release];
    [dateCreated release];
    [imageKey release];
    [super dealloc];
}

- (id)init
{
    self = [super init];
    
    return self;
}

- (id)initWithPossessionName:(NSString *)name valueInDollars:(int)value serialNumber:(NSString *)sNumber
{
    // Call the instance variables initial values
    [super init];
    
    [self setPossessionName:name];
    [self setValueInDollars:value];
    [self setSerialNumber:sNumber];
    dateCreated = [[NSDate alloc] init];
    
    // Return the address of the newly initialized object
    return self;
}

- (NSString *)description
{
    return [NSString stringWithFormat:@"$%d - %@ (%@): Worth $%d, Recorded on %@",
            valueInDollars,
            possessionName,
            serialNumber,
            valueInDollars,
            dateCreated];
}

+ (id)randomPossession
{
    // Create an array of three adjectives
    NSArray *randomAdjectiveList = [NSArray arrayWithObjects:@"Fluffy",
                                                             @"Rusty",
                                                             @"Shiny", nil];
    // Create an array of three nouns
    NSArray *randomNounList = [NSArray arrayWithObjects:@"Bear",
                               @"Spork",
                               @"Mac", nil];
    
    // Get the index of a random adjective/noun from the lists
    int adjectiveIndex = rand() % [randomAdjectiveList count];
    int nounIndex = rand() % [randomNounList count];
    
    NSString *randomName = [NSString stringWithFormat:@"%@ %@",
                            [randomAdjectiveList objectAtIndex:adjectiveIndex],
                            [randomNounList objectAtIndex:nounIndex]];
    
    int randomValue = rand() % 100;
    
    NSString *randomSerialNumber = [NSString stringWithFormat:@"%c%c%c%c%c",
                                    '0' + rand() % 10,
                                    'A' + rand() % 26,
                                    '0' + rand() % 10,
                                    'A' + rand() % 26,
                                    '0' + rand() % 10];
    
    // Once again, ignore the memory problems with this method
    Possession *newPossession = [[self alloc] initWithPossessionName:randomName
                                                      valueInDollars:randomValue
                                                        serialNumber:randomSerialNumber];
    
    return [newPossession autorelease];
}
@end
